//Housing,intermediary and taxes_2;
// all variables are normalaized to X/Y except l_i , i=P,I,R and lambda_i=Y*lambda_i
//with adjustment cost in the form of  (psi/2)p_h(h-h(-1))^2/h_bar 
//related steady state file is Steady-state_RUN_11.
// capital and housing producer are added to the model so p_h and p_k are dynamic
// with adjustment cost on government loan
// %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

var 
//Lagrangians,*******1-6
lambda_P,lambda_I,lambda_R,lambda_B,lambda_m,lambda_phi,

//consumption,*****7-10
c_P,c_I,c_R,c_B,

//housing,******11-14
 h_P, h_I, h_R ,p_R,

//capital  deposit,*****15-18
k,d,r,r_k,

//Mortgage,****19-20
M,r_b,

//bank,****21
a,

//firm,******22-28
w_P,w_I,w_R,l_P,l_I,l_R,Y_f,

//Governemt,29-35
C,T,tr_P,tr_I,tr_R,g ,b_g,

//just for check ,36-37
h,tr,
//38-42
i_k,Y,i_h,p_h,p_k;


 //predetermined_variables N ; 
// %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 varexo tau_l ;//,I_m,I_r,tau_p,phi;tau_l


// %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

load just_for_check_0.mat;
parameters 
  //beta
beta_P,beta_I,beta_B,
 // housing   labor   capital
varphi_h,varphi_l,iota,delta_h,delta_k,
 // taxs
tau_c,tau_w,tau_d,tau_k,tau_wr ,tau_p,//tau_l,
//  I
I_m,I_r,
 // collateral constraint,
rho_m,theta,
 // bank
phi,
 // firm,
iota_P,iota_I,iota_R,alpha_Y,A,
 // Government,
vartheta_P,vartheta_I,vartheta_R,rho_b,Expenditure_G,
//adjusment cost
psi_a,psi_b,psi_k,psi_h,psi_g,b_g_bar,a_bar,h_P_bar,h_I_bar,h_R_bar,i_k_bar,i_h_bar,p_k_bar,p_h_bar;

// define the parameters
 //discount factors

beta_P=0.9916 ;
beta_I=0.9852 ;
beta_B= 0.957;
 %%%level for housing and labor in utility
varphi_h=0.247;
varphi_l=8.0117;
 %%%Inverse labor suplly elasticity
iota=1 ;
 %%%depreciation rate
delta_h=0.0096 ;
delta_k=0.0141 ;
 %%%Taxes
tau_c=0.05 ;
tau_w=0.31; 
tau_wr=0.21 ; 

tau_p=0.014/4 ; //0.0150
tau_d=0.15 ;
tau_k=0.4 ; 
//tau_l=0.0125*0.1483; // 0.013665*0.1483;

 %%%Imputed rents
I_r=0 ; %% 0 to  0.0397
 %%%Mortgage interest deduction
I_m= 1;  %% 1 to 0.8754
 %%%Persistence in borrowing constraint
rho_m=0.85 ;
 %%%loan to valye ratio
theta=0.7 ;
 %%%leverage ratio
phi=0.9; %% 0.9 to 0.93419;
 %%%Labor share in production
iota_P=0.22 ; 
iota_I=0.54 ; 
iota_R= 0.24; 
 %%%capital share in production
alpha_Y=0.2047 ;
A= 1.805;
 %%%Transfer share
vartheta_P=0.040 ; 
vartheta_I=0.036 ; 
vartheta_R= 0.030; 
 %%% response of transfers to gov. debt
rho_b=0.001; %%%;
 %%%propertion of the gov, expenditure over output
Expenditure_G=0.26 ;
//adjustment cost
psi_a=0; %% adjestment cost households 10 age psi_a va psi_k=0 bashand ba meghdare balaye psi_h baz system kar mikonad
psi_b=0;  %% adjestment cost bank 
psi_k=0;   %% adjestment cost capital producer 2.48
psi_h=0;    %% adjestment cost house producer 2.48
psi_g=0;
b_g_bar=b_g_0;
a_bar=a_0;
h_P_bar=h_P_0;
h_I_bar=h_I_0;
h_R_bar=h_R_0;
i_k_bar=i_k_0;
i_h_bar=i_h_0;
p_k_bar=p_k_0;
p_h_bar=p_h_0;
//*********************************************

model;

//lagrangians****************1,2,3,4
   (1+tau_c) * lambda_P= 1/ c_P ;
   (1+tau_c) * lambda_I= 1/ c_I ;
   (1+tau_c) * lambda_R= 1/ c_R ;
   (1+tau_c) * lambda_B= 1/ c_B ;

//budget constraints*****************************
   //Patient Household***5
   (1+tau_c)*c_P+ (h_P-(1-delta_h)* h_P(-1))*p_h+ (h_R-(1-delta_h)* h_R(-1))*p_h+ (k-(1-delta_k)*k(-1))*p_k+ d= 
 w_P *l_P+ p_R* h_R(-1)+ (1+r(-1))*d(-1)+ r_k* k(-1)+ tr_P  - tau_w*(w_P *l_P+(p_R-delta_h)*( h_R(-1)+ I_r*  h_P(-1)) 
- tau_p *p_h *( h_P(-1)+ h_R(-1)))-tau_d* r(-1)* d(-1)-tau_k*(r_k-delta_k)*k(-1)- tau_p *p_h *( h_P(-1)+ h_R(-1))-tau_l *p_h *( h_P+ h_R)
- (psi_a/2)*p_h*(h_P-h_P(-1))^2/h_P_bar - (psi_a/2)*p_h*(h_R-h_R(-1))^2/h_R_bar;

   //ImPatient Household***6
   (1+tau_c)*c_I + (h_I -(1-delta_h)* h_I(-1))*p_h+(1+r_b(-1))*M(-1)= 
w_I* l_I + M + tr_I - tau_w*(w_I *l_I -I_m *r_b(-1)*M(-1)+ I_r*(p_R -delta_h)*  h_I(-1)- tau_p *p_h *  h_I(-1))
- tau_p *p_h *  h_I(-1)- tau_l * p_h *   h_I - (psi_a/2)*p_h*(h_I-h_I(-1))^2/h_I_bar;

   //Renter Household***7
   (1+tau_c)*c_R +p_R*   h_R(-1)= (1-tau_wr)*w_R * l_R +tr_R ;

   //Bank***8,9
   a =b_g +M ;
   // a=M;
   (1+tau_c)* c_B +(1+r(-1))*d(-1)+a+psi_b*(a-a(-1))^2/(2*a_bar) = d +(1+r_b(-1))*a(-1);

// Optimal conditions****************
   //Respect to h_P***10
   (1+ tau_l+ psi_a*(h_P-h_P(-1))/h_P_bar)*p_h  = beta_P* ( (varphi_h/ (lambda_P *  h_P)) + (lambda_P(1)/ lambda_P )*((1- delta_h- tau_p*(1- tau_w))*p_h(1)-I_r * tau_w*(p_R(1)- delta_h)
+psi_a* p_h(1)*(h_P(1)-h_P)/h_P_bar ));

   //Respect to h_R***11
   (1+ tau_l + psi_a*(h_R-h_R(-1))/h_R_bar)* p_h  = beta_P * ( (lambda_P(1)/ lambda_P )*((1- delta_h- tau_p *(1- tau_w))* p_h(1)+(1- tau_w)*p_R(1)+ tau_w * delta_h
+ psi_a * p_h(1)*(h_R(1)-h_R)/h_R_bar ));
 
   //Respect to d***12
   1 = beta_P * ( (lambda_P(1)/ lambda_P )*(1+(1- tau_d)*r )) ; 

   //Respect to k***13
   p_k = beta_P*  ( (lambda_P(1)/ lambda_P )*((1- delta_k)*p_k(1)+(1- tau_k)*r_k(1)+ tau_k*  delta_k));  

   //Respect to h_I***14
   (1+ tau_l-  (lambda_m / lambda_I )*(1- rho_m)* theta+ psi_a*(h_I-h_I(-1))/h_I_bar)* p_h  = beta_I*  ( ( varphi_h/( lambda_I *  h_I)) 
+ (lambda_I(1)/ lambda_I )*((1- delta_h- tau_p * (1- tau_w))*p_h(1)-I_r * tau_w*(p_R(1)- delta_h)+psi_a*p_h(1)*(h_I(1)-h_I)/h_I_bar ));  

   //Respect to Mortgage***15
   1- (lambda_m / lambda_I )= beta_I * ( (lambda_I(1)/ lambda_I )*(1+(1-I_m *tau_w)*r_b - (lambda_m(1)/ lambda_I )* rho_m)) ; 

   //Respect to h_R ***16
   p_R = ( varphi_h/( lambda_R*  h_R(-1)));

   //Respect to labors***17,18,19
  varphi_l *(l_P )^iota= lambda_P * (1- tau_w)*w_P  ; 
  varphi_l *(l_I )^iota= lambda_I * (1- tau_w)*w_I   ;
  varphi_l *(l_R )^iota= lambda_R * (1- tau_wr)*w_R ;  


   //Respect to d bank***20
   1=(lambda_phi/lambda_B)+   beta_B*  (lambda_B(1)/ lambda_B ) *(1+r )  ;

   //Respect to "a": asset bank***21
   1+psi_b*(a-a(-1))/a_bar=(lambda_phi/lambda_B)* phi+  beta_B*  (lambda_B(1)/ lambda_B )*(1+r_b+psi_b*(a(1)-a)/a_bar ) ; 

   //Firm problem
    alpha_Y*Y_f/k(-1)=r_k  ;//22
   (1- alpha_Y)* iota_P* (Y_f /l_P)=w_P ;//23
   (1- alpha_Y)* iota_I* (Y_f /l_I)=w_I ;//24
   (1- alpha_Y)* iota_R* (Y_f /l_R)=w_R ;//25

// borrowing constraint******************************
   M =  rho_m* M(-1)+(1- rho_m)* theta   * h_I ;//26
   d = phi * a ;//27

//Government*********************************
 C =c_P +c_I +c_R +c_B   ;//28

 T = tau_c* C + tau_w*(w_P* l_P +(p_R - delta_h)*( h_R(-1)+I_r * h_P(-1))- tau_p  * ( h_P(-1)+ h_R(-1)))+ tau_d *r(-1)* d(-1) 
 + tau_p * ( h_P(-1)+ h_R(-1))+ tau_l  *( h_P + h_R )+ tau_k*(r_k - delta_k)*k(-1) 
 + tau_w*(w_I* l_I -I_m* r_b(-1)*M(-1)+I_r*(p_R - delta_h)*  h_I(-1)- tau_p   *  h_I(-1))+ tau_p  *   h_I(-1)+ tau_l  *  h_I   
 + tau_wr*w_R*  l_R;   //29

   b_g +T =(1+r_b(-1))*b_g(-1)+g + tr_P + tr_I + tr_R + (psi_g/2)*(b_g-b_g(-1))^2/b_g_bar  ;//30

   tr_P = vartheta_P * Y_f - rho_b* b_g(-1);//31
   tr_I = vartheta_I * Y_f - rho_b* b_g(-1);//32
   tr_R = vartheta_R * Y_f - rho_b* b_g(-1);//33

   g=Expenditure_G; //34

   h=h_P+h_I+h_R;//35
   tr=tr_P+tr_I+tr_R;//36
// non-housing output*********************************
   Y_f = A * k(-1)^alpha_Y * ((l_P )^iota_P * (l_I )^iota_I * (l_R )^iota_R)^(1- alpha_Y);//37

// GDP *********************************
   Y=(1+tau_c)*C+p_R*h(-1)+i_k+i_h+g;//38

// capital and housing producer *********************************
   (1-psi_k*(i_k/i_k(-1)-1)^2/2)*i_k=k-(1-delta_k)*k(-1); //39
   (1-psi_h*(i_h/i_h(-1)-1)^2/2)*i_h= h-(1-delta_h)* h(-1);//40

          //log(i_k/i_k_bar)=(beta_P/(1+beta_P))*log(i_k(1)/i_k_bar)+log(i_k(-1)/i_k_bar)/(1+beta_P)+log(p_k/p_k_bar)/((1+beta_P)*psi_k);//41
          //log(i_h/i_h_bar)=(beta_P/(1+beta_P))*log(i_h(1)/i_h_bar)+log(i_h(-1)/i_h_bar)/(1+beta_P)+log(p_h/p_h_bar)/((1+beta_P)*psi_h);;//42
    p_k-psi_k*p_k*(i_k/i_k(-1)-1)*(i_k/i_k(-1))-psi_k*p_k*(i_k/i_k(-1)-1)^2/2+beta_P*((lambda_P(1)/lambda_P)*psi_k*p_k(1)*(i_k(1)/i_k-1)*(i_k(1)/i_k)^2)=1;//41
    p_h-psi_h*p_h*(i_h/i_h(-1)-1)*(i_h/i_h(-1))-psi_h*p_h*(i_h/i_h(-1)-1)^2/2+beta_P*((lambda_P(1)/lambda_P)*psi_h*p_h(1)*(i_h(1)/i_h-1)*(i_h(1)/i_h)^2)=1;//42


end;
// ***********************************
load just_for_check_0.mat;
initval;
lambda_P=lambda_P_0;lambda_I=lambda_I_0;lambda_R=lambda_R_0;
lambda_B=lambda_B_0;lambda_m=lambda_m_0;lambda_phi=lambda_phi_0;
c_P=c_P_0; c_I=c_I_0; c_R=c_R_0; c_B=c_B_0; 
h_P=h_P_0; h_I=h_I_0; h_R=h_R_0;  p_R=p_R_0;
k=k_0; d=d_0; r=r_0; r_k=r_k_0;M=M_0; r_b=r_b_0;
a=a_0; 
w_P=w_P_0; w_I=w_I_0; w_R=w_R_0;
l_P=l_P_0; l_I=l_I_0; l_R=l_R_0;

C=C_0; T=T_0; b_g=b_g_0; tr_P=tr_P_0; tr_I=tr_I_0; tr_R=tr_R_0; g=g_0;
h=h_0;tr=tr_0;Y=Y_0;Y_f=Y_f_0;i_k=i_k_0;i_h=i_h_0;
//
tau_l=0.0125*0.1483;
end;
// ***********************************

steady;

load just_for_check_end.mat;
endval;
lambda_P=lambda_P_end;lambda_I=lambda_I_end;lambda_R=lambda_R_end;
lambda_B=lambda_B_end;lambda_m=lambda_m_end;lambda_phi=lambda_phi_end;
c_P=c_P_end; c_I=c_I_end; c_R=c_R_end; c_B=c_B_end; 
h_P=h_P_end; h_I=h_I_end; h_R=h_R_end;  p_R=p_R_end;
k=k_end; d=d_end; r=r_end; r_k=r_k_end;M=M_end; r_b=r_b_end;
a=a_end;

w_P=w_P_end; w_I=w_I_end; w_R=w_R_end;
l_P=l_P_end; l_I=l_I_end; l_R=l_R_end;

C=C_end; T=T_end; b_g=b_g_end; tr_P=tr_P_end; tr_I=tr_I_end; tr_R=tr_R_end; g=g_end;
h=h_end;tr=tr_end;Y_f=Y_f_end;i_k=i_k_end; i_h=i_h_end;
//
tau_l=0.013665*0.1483;
end;

steady;


check;
//model_diagnostics ;


perfect_foresight_setup(periods=1000);
options_.simul.robust_lin_solve=1;
perfect_foresight_solver(stack_solve_algo =0);
//simul(periods=100,stack_solve_algo =0);







